; Quick test to try visible overscan size
;
; Builds with Devpac 3 / gen.ttp
;
; 20151016
; ae@dhs.nu


mode:		equ	1				;0=st 230 byte lw, 1=ste 224 byte lw


	ifeq	mode
		output	230_st.tos
	endc

	ifne	mode
		output	224_ste.tos
	endc


		section	text

start:		pea	demo				;Run demo in supervisor
		move.w	#$26,-(sp)			;supexec()
		trap	#14				
		addq.l	#6,sp				

		clr.w	-(sp)				;pterm()
		trap	#1				



demo:
		jsr	save_and_setup
		jsr	copy_graphics_to_screen
		jsr	save_and_setup_mfp

.mainloop:	tst.w	vblcount			;Wait VBL
		beq.s	.mainloop			
		clr.w	vblcount			

		cmp.b	#$39,$fffffc02.w		;Space?
		bne.s	.mainloop			


		jsr	restore
		rts


timer_a:	movem.l	d0-a6,-(sp)

		move.w 	#$0707,$ffff8240.w 		;Purple syncline

		move.w	#$2100,sr			;Enable HBL
		stop	#$2100				;Wait for HBL
		move.w	#$2700,sr			;Stop all interrupts
		clr.b	$fffffa19.w			;Stop Timer A

		dcb.w 	84,$4e71			;Zzzz

		;Top border
		clr.b	$ffff820a.w			;60 Hz
		dcb.w 	9,$4e71
		move.b	#2,$ffff820a.w			;50 Hz


		lea	$ffff8209.w,a0			;Hardsync
		moveq	#127,d1	
.sync:		tst.b	(a0)
		beq.s	.sync
		move.b	(a0),d2	
		sub.b	d2,d1
		lsr.l	d1,d1

		moveq	#2,d7				;D7 used for the overscan code

	ifeq	mode
		dcb.w	58,$4e71
	endc

	ifne	mode
		dcb.w	41,$4e71
	endc


		move.w 	#$0444,$ffff8240.w 		;Grey background during display


	ifeq	mode	
		;ST overscan with stabilizer, 230 byte linewidth
		;228 lines with left/right border
		rept	228
		dcb.w	11,$4e71		
		move.b	d7,$ffff8260.w			;3 71 Hz Left border
		move.w	d7,$ffff8260.w			;3 50 Hz
		dcb.w	88,$4e71
		move.w	d7,$ffff820a.w			;3 60 Hz Right border
		move.b	d7,$ffff820a.w			;3 50 Hz
		dcb.w	11,$4e71
		move.b	d7,$ffff8260.w			;3 71 Hz Stabilizer
		move.w	d7,$ffff8260.w			;3 50 Hz
		endr

		;Special case line for lower border
		dcb.w	8,$4e71		
		move.w	d7,$ffff820a.w			;3 60 Hz Lower border
		move.b	d7,$ffff8260.w			;3 71 Hz Left border
		move.w	d7,$ffff8260.w			;3 60 Hz
		move.b	d7,$ffff820a.w			;3 50 Hz
		dcb.w	85,$4e71			
		move.w	d7,$ffff820a.w			;3 60 Hz Right border
		move.b	d7,$ffff820a.w			;3 50 Hz
		dcb.w	11,$4e71
		move.b	d7,$ffff8260.w			;3 71 Hz Stabilizer
		move.w	d7,$ffff8260.w			;3 50 Hz

		;49 lines with left/right border
		rept	49
		dcb.w	11,$4e71		
		move.b	d7,$ffff8260.w			;3 71 Hz Left border
		move.w	d7,$ffff8260.w			;3 50 Hz
		dcb.w	88,$4e71
		move.w	d7,$ffff820a.w			;3 60 Hz Right border
		move.b	d7,$ffff820a.w			;3 50 Hz
		dcb.w	11,$4e71
		move.b	d7,$ffff8260.w			;3 71 Hz Stabilizer
		move.w	d7,$ffff8260.w			;3 50 Hz
		endr
	endc


	ifne	mode	
		;STe overscan without stabilizer, 224 byte linewidth
		;228 lines with left/right border
		rept	228
		dcb.w	26,$4e71		
		move.b	d7,$ffff8260.w			;3 71 Hz Left border
		move.w	d7,$ffff8260.w			;3 50 Hz
		dcb.w	90,$4e71
		move.w	d7,$ffff820a.w			;3 60 Hz Right border
		move.b	d7,$ffff820a.w			;3 50 Hz
		endr

		;Special case line for lower border
		dcb.w	23,$4e71		
		move.w	d7,$ffff820a.w			;3 60 Hz Lower border
		move.b	d7,$ffff8260.w			;3 71 Hz Left border
		move.w	d7,$ffff8260.w			;3 60 Hz
		move.b	d7,$ffff820a.w			;3 50 Hz
		dcb.w	87,$4e71			
		move.w	d7,$ffff820a.w			;3 60 Hz Right border
		move.b	d7,$ffff820a.w			;3 50 Hz

		;49 lines with left/right border
		rept	49
		dcb.w	26,$4e71		
		move.b	d7,$ffff8260.w			;3 71 Hz Left border
		move.w	d7,$ffff8260.w			;3 50 Hz
		dcb.w	90,$4e71
		move.w	d7,$ffff820a.w			;3 60 Hz Right border
		move.b	d7,$ffff820a.w			;3 50 Hz
		endr
	endc


		move.w 	#$0770,$ffff8240.w 		;Yellow after picture

		movem.l	(sp)+,d0-a6
		rte


vbl:		movem.l	d0-a6,-(sp)

		addq.w	#1,vblcount

		move.w	#$2700,sr			;Stop all interrupts

		;Start up Timer A each VBL
		clr.b	$fffffa19.w			;Timer-A control (stop)
		bset	#5,$fffffa07.w			;Interrupt enable A (Timer A)
		bset	#5,$fffffa13.w			;Interrupt mask A (Timer A)
		move.b	#97,$fffffa1f.w			;Timer A Delay (data)
		move.b	#4,$fffffa19.w			;Timer A Predivider (start Timer A)
		
		bclr	#3,$fffffa17.w			;Automatic end of interrupt

		movem.l	pic,d0-d7
		movem.l	d0-d7,$ffff8240.w

		movem.l	(sp)+,d0-a6
		rte

dummy:		rte



copy_graphics_to_screen:

		;448*288 picture
		move.l 	scraddr,a0
		lea	160(a0),a0
		lea	pic+32,a1

		move.w 	#288-1,d6
.y:		move.w 	#224/4-1,d7
.x:
		move.l 	(a1)+,(a0)+
		dbra	d7,.x

	ifeq	mode
		lea	6(a0),a0			;ST style overscan modulo
	endc
		dbra	d6,.y

		rts


save_and_setup:
		lea	save_screenadr,a0		;Save old screen address
		move.b	$ffff8201.w,(a0)+		
		move.b	$ffff8203.w,(a0)+		
		move.b	$ffff820d.w,(a0)+		

		movem.l	$ffff8240.w,d0-d7		;Save old palette
		movem.l	d0-d7,save_pal

		move.l	#screen+256,d0			;Align new screen address
		clr.b	d0
		move.l	d0,scraddr

		lsr.w	#8,d0				;Set new screen address
		move.l	d0,$ffff8200.w	

		move.b	$ffff8260.w,save_res		;Save old resolution
		clr.b	$ffff8260.w			;Set low resolution

		move.b	$ffff820a.w,save_freq		;Save old refresh
		move.b	#2,$ffff820a.w			;Set 50 Hz

		move.b	#$12,$fffffc02.w		;Kill mouse

		rts



save_and_setup_mfp:

		move.w	#$2700,sr			;Stop all interrupts
		lea	save_vect_mfp,a0
		move.l	$70.w,(a0)+			;Save old VBL
		move.l	$68.w,(a0)+			;Save old HBL
		move.l	$134.w,(a0)+			;Save old Timer A
		move.l	$120.w,(a0)+			;Save old Timer B
		move.l	$114.w,(a0)+			;Save old Timer C
		move.l	$110.w,(a0)+			;Save old Timer D
		move.l	$118.w,(a0)+			;Save old ACIA
		move.b	$fffffa07.w,(a0)+
		move.b	$fffffa09.w,(a0)+
		move.b	$fffffa13.w,(a0)+
		move.b	$fffffa15.w,(a0)+
		move.b	$fffffa19.w,(a0)+
		move.b	$fffffa1b.w,(a0)+
		move.b	$fffffa1f.w,(a0)+
		move.b	$fffffa21.w,(a0)+
		clr.b	$fffffa07.w			;Interrupt enable A (Timer-A & B)
		clr.b	$fffffa13.w			;Interrupt mask A (Timer-A & B)
		clr.b	$fffffa09.w			;Interrupt enable B (Timer-C & D)
		clr.b	$fffffa15.w			;Interrupt mask B (Timer-C & D)

		lea	dummy(pc),a0
		move.l	#vbl,$70.w			;Install our own VBL
		move.l	a0,$68.w			;Install our own HBL
		move.l	#timer_a,$134.w			;Install our own Timer A
		move.l	a0,$120.w			;Install our own Timer B
		move.l	a0,$114.w			;Install our own Timer C
		move.l	a0,$110.w			;Install our own Timer D
		move.l	a0,$118.w			;Install our own ACIA

		move.w	#$2300,sr			;Interrupts back on
		rts


restore:
		move.w	#$2700,sr			;Stop all interrupts
		lea	save_vect_mfp,a0
		move.l	(a0)+,$70.w			;Restore old VBL
		move.l	(a0)+,$68.w			;Restore old HBL
		move.l	(a0)+,$134.w			;Restore old Timer A
		move.l	(a0)+,$120.w			;Restore old Timer B
		move.l	(a0)+,$114.w			;Restore old Timer C
		move.l	(a0)+,$110.w			;Restore old Timer D
		move.l	(a0)+,$118.w			;Restore old ACIA
		move.b	(a0)+,$fffffa07.w
		move.b	(a0)+,$fffffa09.w
		move.b	(a0)+,$fffffa13.w
		move.b	(a0)+,$fffffa15.w
		move.b	(a0)+,$fffffa19.w
		move.b	(a0)+,$fffffa1b.w
		move.b	(a0)+,$fffffa1f.w
		move.b	(a0)+,$fffffa21.w
		move.w	#$2300,sr			;Interrupts back on

		move.b	save_res,$ffff8260.w		;Restore old resolution
		move.b	save_freq,$ffff820a.w		;Restore old refresh

		movem.l	save_pal,d0-d7			;Restore old palette
		movem.l	d0-d7,$ffff8240.w

		lea	save_screenadr,a0		;Restore old screen address
		move.b	(a0)+,$ffff8201.w
		move.b	(a0)+,$ffff8203.w
		move.b	(a0)+,$ffff820d.w

		move.b	#$8,$fffffc02.w			;Enable mouse

		rts








		section	data

pic:		incbin	'pic.4pl' 			;448*288 4 bitplanes and 32 byte palette at the start
		even

		section	bss

scraddr:	ds.l	1
vblcount:	ds.w	1
screen:		ds.b	160+230*288+256	
save_pal:	ds.w	16
save_res:	ds.b	1
save_freq:	ds.b	1
save_screenadr:	ds.l	1
save_vect_mfp:	ds.b	28+8
		even

		end